// C Header File
// Created 5/10/2003; 11:50:18 AM
#define USE_TI89              // Compile for TI-89

// Displays TI-Basic Picture File 'SymName' at (x,y) with attribute 'Attr'
short
basicPic(SYM_STR SymName,short x,short y,short Attr) {
	SYM_ENTRY *sym_entry = SymFindPtr(SymName,0);
	if(!sym_entry) return FALSE;
	if(peek(HToESI(sym_entry->handle))!=PIC_TAG) return FALSE;
	BitmapPut(x,y,HeapDeref(sym_entry->handle)+2,ScrRect,Attr);
	return TRUE;
}

// Waits for a key
void
waitKey() {
	void *kbq = kbd_queue();
	unsigned short key;
	while(OSdequeue(&key,kbq)) key = 0;
}

// Displays a full-screen picture 'pic'
void
display(unsigned char pic[]) {
	unsigned char* plane1;
	unsigned char* plane2;
	unsigned char* dest1;
	unsigned char* dest2;
	unsigned char* src;
	short          loop;
	plane1 = GetPlane(0);
	plane2 = GetPlane(1);
	dest1 = plane1;
	dest2 = plane2;
	src = pic;
	for (loop=0;loop<100;loop++,src+=20,dest1+=30,dest2+=30) {
		memcpy(dest1,src,20);
		memcpy(dest2,src,20);
	}
}

// Displays centered text *str, with font width 'width' centered in area 'area' at y-coord 'y' with
// attribute 'attr'
short
centeredText(const char *str,short width,unsigned short area,short y,short attr) {
	unsigned char old = 0;
	     if(width == 4) old = FontSetSys(F_4x6);
	else if(width == 6) old = FontSetSys(F_6x8);
	else if(width == 8) old = FontSetSys(F_8x10);
	if((strlen(str)*width) > area) return 0;
	short padding = ((area-(strlen(str)*width))/2);
	if(width == 4) DrawStr((padding+(strlen(str)/3)),y,str,attr);
	else           DrawStr(padding,y,str,attr);
	FontSetSys(old);
	return padding;
}

// Gets input to a string
void
input_str(char *str,short x,short y,short maxlen) {
	short i=0,key=0,len=maxlen;
	while(key != KEY_ENTER) {
		str[i]='_'; str[i+1]=' '; str[i+2]=0;
		DrawStr(x,y,str,A_NORMAL);
		key=ngetchx();
		if(key == KEY_ESC) break;
		if(key>=' '&&key<='~'&&i<len) {str[i] = ' ';DrawStr(x,y,str,A_REPLACE);str[i++]=key;};
		if(key==257&&i) {str[i] = ' ';DrawStr(x,y,str,A_REPLACE);i--;str[i] = ' ';DrawStr(x,y,str,A_REPLACE);};
		if(key=='\\'&&i) len=strlen(str)+7;
	}
	str[i]=0;
}

SCR_RECT full_screen = {{0,0,159,99}};

// Saves the entire screen to screen
void
saveScrn(char *screen) {
	BitmapGet (&full_screen,screen);
}

// Loads the entire screen from screen
void
loadScrn(char *screen) {
	BitmapPut (0,0,screen,&full_screen,A_REPLACE);
}

// Displays keys summary
void
keys() {
	OSSetSR(0x0000);
	clrscr();
	GKeyFlush();
	centeredText("Keys",8,160,21,A_NORMAL);
	centeredText("Arrow Keys : Move Crosshairs",4,160,31,A_NORMAL);
	centeredText("2nd : Fire",4,160,37,A_NORMAL);
	centeredText("Diamond : Reload",4,160,43,A_NORMAL);
	centeredText("X : Sniper Rifle",4,160,49,A_NORMAL);
	centeredText("Y : Submachine Gun",4,160,55,A_NORMAL);
	centeredText("<- : Select new target",4,160,61,A_NORMAL);
	centeredText("Clear : Clear Bullet Holes",4,160,67,A_NORMAL);
	centeredText("F1 : Keys (this screen)",4,160,73,A_NORMAL);
	centeredText("ESC : Exit",4,160,79,A_NORMAL);
	ngetchx();
	OSSetSR(0x0700); EnableAutoInt3();
}

void newPic();

// Start up the game & init the screen & save
void
startScreen() {
start:
	clrscr();
	centeredText("Gun Range 89",8,160,40,A_NORMAL);
	centeredText("by Kevin Chang",6,160,50,A_NORMAL);
	centeredText("Press F1 for keys",4,160,87,A_NORMAL);
	centeredText("Press ESC to exit",4,160,94,A_NORMAL);
	short key = ngetchx();
	if(key == KEY_F1) {
		keys();
		goto start;
	} else if(key == KEY_ESC) exit(0);
	newPic();
}

char firstrun = 'y';

// gets a new target pic from default or basic pic
// uses display if first run (before bitmap-type save)
void
newPic() {
	OSSetSR(0x0000);
	clrscr();
	GKeyFlush();
	centeredText("Do you want to use an external target?",4,160,46,A_NORMAL);
	centeredText("F1=YES    F5=NO",6,160,52,A_NORMAL);
	short key = 0;
restrt:
	key = ngetchx();
	if(key == KEY_F5) {
deflt:
		clrscr();
		if(firstrun == 'y') {
			display(room);
			firstrun = 'n';
		} else {
			loadScrn(room);
		}
		Sprite32(64,3,20,patch,LCD_MEM,SPRT_AND);
		Sprite32(64,23,20,patch,LCD_MEM,SPRT_AND);
		Sprite32(64,37,20,patch,LCD_MEM,SPRT_AND);
		Sprite32(64,3,54,generic,LCD_MEM,SPRT_OR);
	} else if(key == KEY_F1) {
		char fname[18];
		short xcoord = 0;
enName:	
		clrscr();
		xcoord = centeredText("Enter the name of the file:",4,160,46,A_NORMAL);
		centeredText("Enter \"NONE\" to use default",4,160,63,A_NORMAL);
		input_str(fname,xcoord+9,54,8);
		SYM_ENTRY *sym;
		sym = SymFindPtr(SYMSTR(fname),0);
		unsigned short size = ((MULTI_EXPR*) HeapDeref (sym->handle))->Size + 2;
		ESQ type = *(HToESI (sym->handle));
		if((type != PIC_TAG || size > 223) && (strcmp(fname,"NONE") != 0)) {
			centeredText("ERROR: Invalid File",6,160,92,A_NORMAL);
			GKeyFlush();
			xcoord = 0;
			while(xcoord < 30000) {
				xcoord+=1;
			}
			xcoord = 0;
			waitKey();
			goto enName;
		}
		clrscr();
		if(firstrun == 'y') {
			display(room);
		} else {
			loadScrn(room);
		}
		if((xcoord = basicPic(SYMSTR(fname),64,3,A_REPLACE)) == FALSE) {clrscr();goto deflt;};
		firstrun = 'n';
	} else if(key == KEY_ESC) {
		exit(0);
	} else {
		goto restrt;
	}
	saveScrn(room);
	OSSetSR(0x0700); EnableAutoInt3();
	return;
}

// Displays the animation and pause when changing clip (out of bullets)
void
changeClip(short bullets,short *clip){
	unsigned char old = FontSetSys(F_4x6);
	DrawStr(55,85,"Changing clip...",A_NORMAL);
	FontSetSys(old);
	Sprite8(55,91,8,barSide,LCD_MEM,SPRT_XOR);
	Sprite8(106,91,8,barSide,LCD_MEM,SPRT_XOR);
	unsigned short c = 56;
	while(c<106) {
		Sprite8(c,91,8,barBody,LCD_MEM,SPRT_XOR);
		c+=1;
	}
	c = 0;
	while(c < 13000) {
		Sprite8((c/260)+56,91,8,bar,LCD_MEM,SPRT_OR);
		c+=1;
		if(c == 13000) break;
	}
	*clip = bullets; 
	Sprite32(55,85,20,patch,LCD_MEM,SPRT_AND);
	Sprite32(85,85,20,patch,LCD_MEM,SPRT_AND);
}

// Displays the number of bullets in the current clip
void
dispBullets(short *clip) {
	Sprite32(6,86,20,patch,LCD_MEM,SPRT_AND);
	unsigned char old = FontSetSys(F_8x10);
	if(*clip < 10) printf_xy(6,86,"0%d",*clip);
	else printf_xy(6,86,"%d",*clip);
	FontSetSys(old);
}

// Displays the statistics of your shooting
void
dispStats(short shots,short hit) {
	Sprite32(142,86,20,patch,LCD_MEM,SPRT_AND);
	unsigned char old = FontSetSys(F_4x6);
	short hPct = (short)((((double)hit )/((double)shots))*100);
	short mPct = 100-hPct;
	if(shots == 0) {
		printf_xy(142,86,"0%%");
		printf_xy(142,92,"0%%");
	} else {
		printf_xy(142,86,"%d%%",hPct);
		printf_xy(142,92,"%d%%",mPct);
	}
	FontSetSys(old);
}

// the heart of the game
// a modified version of my shooting engine
// yes, i know, it's huge & inefficient, but it is fast enough for its purpose
void
game() {
	short x = 76;
	short y = 17;
	short loop = 1;
	short fire = 0;
	unsigned short delay = 25;
	short fireD = 0;
	short recoil = 6;
	short shake = 2;
	short xdelt = 2;
	short ydelt = 2;
	short clipRifle = 5;
	short clipSMG = 30;
	short *clip = &clipRifle;
	short bullets = 5;
	short shots = 0;
	short hit = 0;
	short xcoord[1024] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
						  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	short ycoord[1024] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
						  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	unsigned short idx = 0;
	startScreen();
	Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR); 
	dispBullets(clip);
	dispStats(shots,hit);
	OSSetSR(0x0700); EnableAutoInt3();
	while(loop == 1)
	{
		delay = delay + 1;
		if(delay == 10000)
		{
			OSSetSR(0x0700); EnableAutoInt3();
			if(_keytest(RR_UP) || _keytest(RR_DOWN) || _keytest(RR_LEFT) || _keytest(RR_RIGHT)) {
				if(_keytest (RR_UP)) {
					if(y > 0) {
						Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
						y-=ydelt;
						if(y < 0) y = 0;
						Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
					}
				} if(_keytest (RR_DOWN)) {
					if(y < 53)	{
						Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
						y+=ydelt;
						if(y > 53) y = 53;
						Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
					}
				} if(_keytest (RR_LEFT)) {
					if(x > 45) {	
						Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
						x-=xdelt;
						if(x < 45) x = 45;
						Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
					}
				} if(_keytest (RR_RIGHT)) {
					if(x < 108) {	
						Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
						x+=xdelt;
						if(x > 108) x = 108;
						Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
					}
				}
			} if(_keytest (RR_2ND)) {
				fire++;
				if (fire > fireD) {
					Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
					if(x == 0) x++;
					Sprite8(x+3,y+3,2,bulletHole,LCD_MEM,SPRT_OR);
					if(idx < 1024) {xcoord[idx] = x+3; ycoord[idx] = y+3; idx+=1;};
					y -= recoil;
					x += (random(2*shake)-shake);
					if(y < 0) y = 0; if(y > 53) y = 53;
					if(x < 45) x = 45; if(x > 108) x = 108;
					if(x >= 59 && x <= 93 && y >= 0 && y <= 53) {
						shots+=1;
						hit+=1;
					} else {
						shots+=1;
					}
					*clip-=1;
					dispStats(shots,hit); dispBullets(clip);
					if(*clip == 0) {
						changeClip(bullets,clip);
						Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
						dispBullets(clip);
						continue;
					}
					Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
					fire = 0;
					while(_keytest(RR_2ND) && fireD == 0) {
						fire=0;
					}
				}
			} else if(_keytest(RR_DIAMOND)) {
				Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
				changeClip(bullets,clip);
				if(y < 0) y = 0; if(y > 59) y = 59;
				if(x < 45) x = 45; if(x > 114) x = 114;
				dispBullets(clip);
				Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
			} else if(_keytest(RR_F1)) {
				Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
				keys();
				loadScrn(room);
				dispBullets(clip);
				dispStats(shots,hit);
				unsigned short temp = idx;
				idx = 0;
				while(idx < 1024) {
					if(xcoord[idx] == 0 && ycoord[idx] == 0) {
						idx+=1;
						continue;
					}
					Sprite8(xcoord[idx],ycoord[idx],2,bulletHole,LCD_MEM,SPRT_OR);
					idx+=1;
				}
				idx = temp;
				Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
			} else if(_keytest (RR_ESC)) {
				loop = 0;
			} else if(_keytest(RR_BCKSPC)) {
				Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
				newPic();
				idx = 0;
				while(idx < 1024) {
					xcoord[idx] = ycoord[idx] = 0;
					idx+=1;
				}
				idx = 0;
				shots = 0;
				hit = 0;
				loadScrn(room);
				dispBullets(clip);
				dispStats(shots,hit);
				Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
			} else if(_keytest (RR_CLEAR)) {
				Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
				clrscr();
				idx = 0;
				while(idx < 1024) {
					xcoord[idx] = ycoord[idx] = 0;
					idx+=1;
				}
				idx = 0;
				shots = 0;
				hit = 0;
				loadScrn(room);
				dispBullets(clip);
				dispStats(shots,hit);
				Sprite8(x,y,7,crosshair,LCD_MEM,SPRT_XOR);
			} else if (_keytest (RR_X)) {
				fireD = 0;
				recoil = 5;
				shake = 2;
				xdelt = 2;
				ydelt = 2;
				clip = &clipRifle;
				bullets = 5;
				dispBullets(clip);
			} else if (_keytest (RR_Y)) {
				fireD = 1;
				recoil = 7;
				shake = 5;
				xdelt = 3;
				ydelt = 3;
				clip = &clipSMG;
				bullets = 30;
				dispBullets(clip);
			}
			delay = 0;
		}
	}
}